#include "Utils.h"

#include <Messenger.h>

int32 GetActiveWindowIndex(BMessenger *msgr) {
	int32 index = B_ERROR;
	BMessage reply(B_REPLY);
	BMessage request(B_COUNT_PROPERTIES);
	request.AddSpecifier("Window");

	status_t result = msgr->SendMessage(&request, &reply);
	if (result != B_OK) return B_ERROR;

	int32 windowCount = B_ERROR;
	if (reply.FindInt32("result", &windowCount) != B_OK) return B_ERROR;
	
	for (int32 i = 0; i < windowCount; i++) {
		request.MakeEmpty();
		reply.MakeEmpty();
		
		request.what = B_GET_PROPERTY;
		request.AddSpecifier("Active");
		request.AddSpecifier("Window", i);
		
		if (msgr->SendMessage(&request, &reply) != B_OK) continue;
		
		bool active = false;
		if (reply.FindBool("result", &active) != B_OK) continue;
		
		if (active == true) {
			index = i;
			break;
		};
	};
	
	return index;
};
